//
//  main.c
//  hqx
//
//  Created by Thorsten Lemke on 26.12.18.
//  Copyright © 2018 Thorsten Lemke. All rights reserved.
//

#include <stdio.h>
#include <stdlib.h>
#include "hqx.h"

int main(int argc, const char * argv[])
{

    if (argc<6)
    {
        printf("usage ha´qx sourcePath destPath kind (2..4) width height");
        return 1;
    }
    
    char *srcPath = (char *)argv[1];
    char *dstPath = (char *)argv[2];
    long kind = atoi(argv[3]);
    int width = atoi(argv[4]);
    int height = atoi(argv[5]);

    if (kind<2 || kind>4)
    {
        printf("usage ha´qx sourcePath destPath kind (2..4) width height");
        return 1;
    }

    uint32_t *src = NULL;
    long dataLen = 0;
    
    FILE *fp = fopen (srcPath , "rb" );
    if (fp)
    {
        fseek (fp , 0 , SEEK_END);
        dataLen = ftell (fp);
        rewind (fp);
        
        src = malloc(dataLen);
        fread(src, 1, dataLen, fp);
        
        fclose(fp);
    }
    else
    {
        return 1;
    }

    hqxInit();
    uint32_t *dst = NULL;
    long dstLen = 0;
    if (kind==4)
    {
        dstLen = width*4*height*4*sizeof(uint32_t);
        dst = (uint32_t *)malloc(dstLen);
        hq4x_32(src, dst, width, height);
    }
    if (kind==3)
    {
        dstLen = width*3*height*3*sizeof(uint32_t);
        dst = (uint32_t *)malloc(dstLen);
        hq3x_32(src, dst, width, height);
    }
    if (kind==2)
    {
        dstLen = width*2*height*2*sizeof(uint32_t);
        dst = (uint32_t *)malloc(dstLen);
        hq2x_32(src, dst, width, height);
    }

    fp = fopen (dstPath , "wb" );
    fwrite(dst, 1, dstLen, fp);
    fclose(fp);
    
    free(dst);
    
    return 0;
}
